part of 'soliq_id_bloc.dart';

abstract class SoliqIdState extends Equatable {
  const SoliqIdState();
}

class SoliqIdInitial extends SoliqIdState {
  @override
  List<Object> get props => [];
}

class SoliqIdAccountInfoSuccessState extends SoliqIdState {
  final AccountInfoModel response;

  const SoliqIdAccountInfoSuccessState({
    required this.response,
  });

  @override
  List<Object?> get props => [response,];
}

class SoliqIdCreateSessionSuccessState extends SoliqIdState {
  final CreateSession response;

 const SoliqIdCreateSessionSuccessState({required this.response,});
  @override
  List<Object?> get props => [response,];
}

class SoliqIdProcessSuccessState extends SoliqIdState {
  final ProcessResponseModel response;

  const SoliqIdProcessSuccessState({required this.response});
  @override
  List<Object?> get props => [response,];
}

class SoliqIdCompareFaceSuccessState extends SoliqIdState {
  final CompareFaceResponse response;

  const SoliqIdCompareFaceSuccessState({required this.response,});

@override
  List<Object?> get props => [response,];
}



class SoliqIdPinflErrorState extends SoliqIdState{
  @override
  List<Object?> get props => [];
}

class SoliqIdErrorState extends SoliqIdState{
  final String error;

  const SoliqIdErrorState({required this.error});

  @override
  List<Object?> get props => [
    error,
  ];
}



class SoliqIdPinflLoadingState extends SoliqIdState{
  @override
  List<Object?> get props => [];
}

class SoliqIdCompareFaceLoadingState extends SoliqIdState{
  @override
  List<Object?> get props => [];

}
