import 'package:dio/dio.dart';

import 'api_interceptor.dart';

class DioModule {
  // String get host => 'api.myfaceid.uz';
  String get host => 'api.yuzid.uz';

  // String get testHost => 'dev-mobile.soliq.uz';
  String get testHost => 'api.yuzid.uz';

  bool get isTest => const bool.hasEnvironment("isTest");

  Future<Dio> getAuthorizedDioClient() async {
    String baseUrl = 'https://${isTest ? testHost : host}/';
    final authorizedDioClient = _createDioClient(baseUrl);
    authorizedDioClient.interceptors.addAll(
      [
        AuthorizedRequestInterceptor(),
      ],
    );
    return authorizedDioClient;
  }

  Future<Dio> getUnauthorizedDioClient({
    required bool isTest,
    required String host,
    required String testHost,
  }) async {
    String baseUrl = 'https://${isTest ? testHost : host}/';
    final unauthorizedDioClient = _createDioClient(baseUrl);
    unauthorizedDioClient.interceptors.addAll(
      [
        CommonRequestInterceptor(),
      ],
    );
    return unauthorizedDioClient;
  }

  Dio _createDioClient(String baseUrl) {
    final options = BaseOptions(
      baseUrl: baseUrl,
      receiveDataWhenStatusError: true,
    );
    return Dio(options);
  }
}
