import 'package:soliq_id/src/data/model/response/response_model.dart';

extension NetworkResponseExtension on NetworkResponseModel {
  bool get isStatus =>
      status &&
      response != null &&
      response!.data != null &&
      response!.data.containsKey("success") &&
      response!.data["success"];

  bool get resultIsList =>
      status &&
      response != null &&
      response!.data != null &&
      containsResult() &&
      response!.data["result"] is List;

  bool containsKey({required String key}) => response!.data.containsKey(key);

  bool containsResult() => response!.data.containsKey("result");

  bool innerContainsKey({
    required String key,
    required String innerKey,
  }) =>
      response!.data[key].containsKey(innerKey);
}
