class AngleModel{
  final double X;
  final double Y;
  final double Z;

  AngleModel({
    this.X = 0.0,
    this.Y = 0.0,
    this.Z = 0.0
  });

  static double XTopInt = 15;
  static double XTopExt = 25;
  static double XBottomInt = -15;
  static double XBottomExt = -25;
  static double YRightInt = 15;
  static double YRightExt = 25;
  static double YLeftInt = -15;
  static double YLeftExt = -25;

  static double LookRight = 7;

  static double MinFaceSize = 300;
  static double MaxFaceSize = 550;

  static double MinFaceTurningHorizontal = 30;
  static double MaxFaceTurningHorizontal = 40;

  static double MinFaceTurningVertical = 15;
  static double MaxFaceTurningVertical = 25;

  static List<FacePosition> fullPositions = [FacePosition.Top, FacePosition.TopRight, FacePosition.Right, FacePosition.BottomRight, FacePosition.Bottom, FacePosition.BottomLeft, FacePosition.Left, FacePosition.TopLeft];
}

class PositionModel{
  final int id;
  final String title;
  final TaskVariantEnum variant;
  final String image;

  PositionModel({required this.id, required this.title, required this.variant, required this.image});
}

class ClientDoneExercises{
  int id;
  DateTime date;

  ClientDoneExercises({
    required this.id,
    required this.date
  });
}


enum FacePosition {Top, TopRight, Right, BottomRight, Bottom, BottomLeft, Left, TopLeft}

enum TaskVariantEnum {top, right, down, left, blink, smile, straight, noFace, multipleFace, nearDistance, longDistance, defaultPose}

enum Idle {brightness, task, capture, done}

enum VoiceType {success, error, turn, none}