import 'package:soliq_id/src/data/dio/type_parse_service.dart';
import 'package:soliq_id/src/data/model/response/data_model.dart';

class AccountInfoModel{
  final bool success;
  final int code;
  final String message;
  final DataModel data;
  final int id;

  AccountInfoModel({
    required this.id,
    required this.success,
    required this.code,
    required this.message,
    required this.data,
  });

  factory AccountInfoModel.fromJson(Map<String, dynamic> response) {
    return AccountInfoModel(
      id: parseToInt(response, "id"),
      success: parseToBool(response, "success"),
      code: parseToInt(response, "code"),
      message: parseToString(response, "message"),
      data: response.containsKey("data") && response["data"] != null ? DataModel.fromJson(response["data"]) : DataModel.example(),
    );
  }

}