import 'package:soliq_id/src/data/dio/type_parse_service.dart';

class CreateSession {
  final String sessionId;
  final String controlKey;
  final int lifeTime;
  final List<int> tasks;

  CreateSession({
    required this.sessionId,
    required this.controlKey,
    required this.lifeTime,
    required this.tasks,
  });

  factory CreateSession.fromMap(Map<String, dynamic> response) {
    return CreateSession(
      sessionId: parseToString(response, "sessionId"),
      controlKey: parseToString(response, "controlKey"),
      lifeTime: parseToInt(response, "lifeTime"),
      tasks: response.containsKey("tasks") &&
              response["tasks"] != null &&
              response["tasks"] is List
          ? List<int>.from(response['tasks'])
          : [],
    );
  }
}
