import 'package:soliq_id/src/data/dio/type_parse_service.dart';

class DeviceModel {
  final String deviceId;
  final int projectId;
  final String deviceName;
  final String factoryName;
  final String osVersion;
  final String appVersion;
  final int osType;
  final String firebaseId;
  final String lang;

  DeviceModel({
    required this.deviceId,
    required this.projectId,
    required this.deviceName,
    required this.factoryName,
    required this.osVersion,
    required this.appVersion,
    required this.osType,
    required this.firebaseId,
    required this.lang,
  });

  factory DeviceModel.fromJson(Map<String, dynamic> response) {
    return DeviceModel(
      deviceId: parseToString(response, "deviceId"),
      projectId: parseToInt(response, "projectId"),
      deviceName: parseToString(response, "deviceName"),
      factoryName: parseToString(response, "factoryName"),
      osVersion: parseToString(response, "osVersion"),
      appVersion: parseToString(response, "appVersion"),
      osType: parseToInt(response, "osType"),
      firebaseId: parseToString(response, "firebaseId"),
      lang: parseToString(response, "lang"),
    );
  }

  Map<String, dynamic> toJson() => <String, dynamic>{
        'deviceId': deviceId,
        'projectId': projectId,
        'deviceName': deviceName,
        'factoryName': factoryName,
        'osVersion': osVersion,
        'appVersion': appVersion,
        'osType': osType,
        'firebaseId': firebaseId,
        'lang': lang,
      };

  // factory DeviceModel.example() {
  //   return DeviceModel(
  //     deviceId: "deviceId",
  //     projectId: 1,
  //     deviceName: "deviceName",
  //     factoryName: "factoryName",
  //     osVersion: "osVersion",
  //     appVersion: "appVersion",
  //     osType: 1,
  //     firebaseId: "firebaseId",
  //     lang: "uz",
  //   );
  // }
}
