import 'package:shared_preferences/shared_preferences.dart';

class Preference {
  SharedPreferences? prefs;

  Future<Preference> init() async {
    if (!isInit) {
      prefs = await SharedPreferences.getInstance();
    }
    return this;
  }

  bool get isInit {
    return prefs != null;
  }
  Future setGUID(String? token) async {
    if (token == null) {
      return prefs?.remove('guid');
    }
    return await prefs?.setString('guid', token);
  }
  Future removeGUID() async => await prefs?.remove('guid');

  Future setLaunchType(bool isFirst) async =>
      await prefs?.setBool('is_first', isFirst);

  bool get isFirstLaunch => prefs?.getBool('is_first') ?? true;

  Future setPrefix(String prefix) async =>
      await prefs?.setString('lang', prefix);

  Future setRefreshToken(String? token) async {
    if (token == null) {
      return prefs?.remove('refresh_token');
    }
    return await prefs?.setString('refresh_token', token);
  }

  String? get refreshToken => prefs?.getString('refresh_token');

  Future setSessionId(String? token) async {
    if (token == null) {
      return prefs?.remove('session-id');
    }
    return await prefs?.setString('session-id', token);
  }

  String get sessionId => prefs?.getString('session-id') ?? "";

  Future setAccessToken(String? token) async {
    if (token == null) {
      return await prefs?.remove('access_token');
    }

    return await prefs?.setString('access_token', token);
  }

  String? get accessToken => prefs?.getString('access_token');


  Future<bool?> setLang(String lang) async {
    return await prefs?.setString('lang', lang);
  }

  Future<String> getLang() async {
    return prefs?.getString('lang') ?? "uz";
  }
}
