import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';

import '../../utils/assets.dart';
import '../../utils/faceid_localizations.dart';
import 'custom_textformfield.dart';

class MainWidget extends StatelessWidget {
  const MainWidget({
    Key? key,
    required this.controller,
  }) : super(key: key);
  final TextEditingController controller;

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Align(
          alignment: Alignment.topCenter,
          child: SvgPicture.asset(Assets.logo),
        ),
        const SizedBox(
          height: 40,
        ),
        CustomTextFormField(
          controller: controller,
          prefix: const SizedBox(),
          hintText: getTranslated(context, 'pinfl'),
          textInputType: TextInputType.number,
          suffix: InkWell(
            onTap: () {},
            child: Padding(
              padding: const EdgeInsets.all(11.0),
              child: SvgPicture.asset(
                Assets.icon_btn,
              ),
            ),
          ),
        ),
      ],
    );
  }
}
