import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'color_utils.dart';

class Dialogs {
  static void showDialogYesOrNot(
    BuildContext context, {
    required Function() onYesTap,
    Widget? content,
    Function()? onNoTap,
    String? title,
    String? noTitle,
    String? yesTitle,
    String? positiveText,
    String? negativeText,
    Widget? titleIcon,
  }) {
    showCupertinoDialog(
        context: context,
        builder: (_) {
          return CupertinoAlertDialog(
            title: titleIcon ?? Text(title ?? ''),
            content: content,
            actions: <Widget>[
              CupertinoDialogAction(
                onPressed: onNoTap ??
                    () {
                      Navigator.pop(context);
                    },
                child: Text(
                  noTitle ?? "",
                  style: const TextStyle(color: Colors.red),
                ),
              ),
              CupertinoDialogAction(
                  isDefaultAction: true,
                  onPressed: onYesTap,
                  child: Text(
                    yesTitle ?? "",
                    style: const TextStyle(color: Colors.black),
                  )),
            ],
          );
        });
  }

  static void showDialogOk(String title, BuildContext context,
      {Function()? onYesTap,
      String? buttonText,
      bool? dismissible,
      TextAlign textAlign = TextAlign.center}) {
    showCupertinoDialog(
        context: context,
        barrierDismissible: dismissible ?? true,
        builder: (_) {
          return CupertinoAlertDialog(
            title: Text(
              title,
              textAlign: textAlign,
            ),
            actions: <Widget>[
              CupertinoDialogAction(
                isDefaultAction: true,
                child: Text(
                  buttonText ?? "OK",
                  style: const TextStyle(color: AppColor.custom_redColor),
                ),
                onPressed: () {
                  Navigator.pop(context);
                  if (onYesTap != null) onYesTap();
                },
              ),
            ],
          );
        });
  }
}
